exception Parse_Error;;
type token = Int | PLUS | TIMES | LPAR | RPAR | Eof;;
(* Voici un analyseur descendant recursif deterministe  *)
(* Remaquez la correspondence exacte avec la table dans *)
(* les notes de cours                                   *)

(* Pour l'affichage des erreurs, on applique une strategie *)
(* simple: on affiche le numero du token sur lequel on a   *)
(* rencontre l'erreur, et on imprime FIRST(X), i.e. les    *)
(* tokens que l'on s'attendait de voir en produisant X     *)

let descente gettoken = 
 let position = ref 1          (* le compteur de position des tokens *)
 and tok = ref (gettoken()) in
 let advance () = tok := gettoken(); position := !position+1 in
 let eat t = if (!tok = t) then advance() else raise Parse_Error in
 let check t = if (!tok = t) then () else raise Parse_Error in
 let perror s = print_string ("Expecting "^s^" at position: "); 
                print_int !position; print_newline(); raise Parse_Error in
 let rec ntS () = match !tok with 
                                 Int  -> (ntE(); check(Eof))
                             |   LPAR -> (ntE(); check(Eof))
                             |   _    ->  perror "int or ("
 and ntE () = match !tok with 
                    Int    -> (ntT(); ntE'())
                 |  LPAR   -> (ntT(); ntE'())
                 |  _      -> perror "int or ("
 and ntE' () = match !tok with 
                    PLUS -> (eat(PLUS); ntT(); ntE'())
                 |  RPAR -> () (* transition vide *)
                 |  Eof  -> () (* transition vide *)
                 |  _    -> perror "+ or ) or eof"
 and ntT () = match !tok with 
                    Int    -> (ntF();ntT'())
                 |  LPAR   -> (ntF();ntT'())
                 |  _      -> perror "int or ("
 and ntT' () = match !tok with 
                    TIMES -> (eat(TIMES); ntF(); ntT'())
                 |  PLUS  -> () (* transition vide *)
                 |  RPAR  -> () (* transition vide *)
                 |  Eof   -> () (* transition vide *)
                 |  _     -> perror "+ or * or ) or eof"
 and ntF () = match !tok with 
                    Int   -> (eat(Int))
                 |  LPAR  -> (eat(LPAR);ntE();eat(RPAR))
                 |  _     -> perror "int or ("
in ntS();;

